#include "Display.h"
#include "CharTable.h"

void Display::sendDisplayCMD(uint8_t cmd){

};
void Display::begin(void){
    //TODO: change pin to #defines, first check if Wire.begin was already called
    Wire.begin(1,2);
    //set Mux Ratio
    sendDisplayCMD(client,muxRatio);
    sendDisplayCMD(client,0x3f);

    sendDisplayCMD(client,setOffset);
    sendDisplayCMD(client,0x00);

    sendDisplayCMD(client, setStartLine);


    /*x-flip*/
    //sendDisplayCMD(client,setSegmentMap);
    sendDisplayCMD(client, setSegmentReMap);
    
    /*mapping of the rows*/
    sendDisplayCMD(client,setComHardwareConfig);
    sendDisplayCMD(client,0x10);

    /*y-flip*/
    //sendDisplayCMD(client, setComDirectionNormal);
    sendDisplayCMD(client, setComDirectionFlipped);

    sendDisplayCMD(client, setContrast);
    sendDisplayCMD(client, 0x7f);

    sendDisplayCMD(client,stopCompleteOn);

    /*which pixels are bright: normal = 1s are bright, inverese= 0s are bright*/
    sendDisplayCMD(client, setNormalMode);
    //sendDisplayCMD(client, setInverseMode);

    sendDisplayCMD(client, setOscFreq);
    sendDisplayCMD(client,0x80);

    sendDisplayCMD(client,setChargePump);
    sendDisplayCMD(client,0x14);

    sendDisplayCMD(client, activateDisplay);
    return;
};
void Display::clear(void){
    
    int index=0;
    sendDisplayCMD(client,addressingMode);
    sendDisplayCMD(client,0x00); //horizontal
    printk(KERN_ALERT "DEBUG: Passed %s %d \n",__FUNCTION__,__LINE__);
    sendDisplayCMD(client,colRange);
    sendDisplayCMD(client,0x00);
    sendDisplayCMD(client,0x7f);
    printk(KERN_ALERT "DEBUG: Passed %s %d \n",__FUNCTION__,__LINE__);
    sendDisplayCMD(client,pageRange);
    sendDisplayCMD(client,0x00);
    sendDisplayCMD(client,0x07);
    printk(KERN_ALERT "DEBUG: Passed %s %d \n",__FUNCTION__,__LINE__);
    i2c_data[0]=data_byte;
    for(index=1;index<128*8;index++){i2c_data[index]=0x00;}
    printk(KERN_ALERT "DEBUG: Passed %s %d \n",__FUNCTION__,__LINE__);
    Wire.beginTransmission(DisplayAdress);
    Wire.write(data_byte);
    Wire.endTransmission();
    //Wire only has a 32-Byte Buffer for transmission
    for(uint index= 0; index<4;index++){
        Wire.beginTransmission(DisplayAdress);
        for(uint bufferIndex = 0;bufferIndex<32;bufferIndex++){
            Wire.write(0x00);
        }
        Wire.endTransmission();
    } 
    return;
};

/**
 * @brief updates amount of chars on current rows and also the current row
 * 
 * @param charAmount how many chars were added 
 */
void Display::updateLine(int charAmount)
{
    if(charAmount+this->charsOnCurrLine>16)
    {
        this->currLine = (this->currLine+((charAmount+this->charsOnCurrLine)/16))%8;
        this->charsOnCurrLine = (charAmount+this->charsOnCurrLine)%17; //there can be 0-16 chars on one line, so the 17th char is on next line 
    }
    else
    {
        this->charsOnCurrLine = this->charAmount+this->charsOnCurrLine;
    }
}


void Display::print(char *value){
    int i = 0;
    char nextchar;
	/* write data to the buffer */
    while(value && value != '\0') //check if pointer is still valid and string is not terminated 
        {
	        //check if input is a predefined cmd
            if(*value=='/')
            {
                nextchar = *value+1;
                if(nextchar=='c')
                {
                    Display::clearDisplay();
                    this->currLine = 0; 
                    this->charsOnCurrLine = 0;
                }
                else if(nextchar=='n')
                {
                    if(this->charsOnCurrLine==16)
                    {
                        this->currLine=currLine+1;
                        this->charsOnCurrLine=0;
                    }
                    while(this->charsOnCurrLine<17)
                    {
                        Wire.beginTransmission(Display_Adress);
                        for(int i = 0;i<9;i++){
                            Wire.write(font8x8_colwise[0][i]);
                        }
                        Wire.endTransmission();
                        updateLine(1);
                        if(charsOnCurrLine==16)
                        {
                            break;
                        }
                    }
                }
                i=i+1;
            }
            else
            {
                updateLine(1);
                Wire.beginTransmission(DisplayAdress);
                for(int i = 0;i<9;i++){
                            Wire.write(font8x8_colwise[*value][i]);
                }
                Wire.endTransmission();
            }
                      
        }
   // }
	
	return;

};
void Display::println(char *value){

};
void Display::print(int value){
    
};